#include <Ice/Ice.h>
#include <Ice/Service.h>
#include "srv.h"
#include <string>
using std::string;
#include <iostream>

//----------------------------------------------------------------------
class HS_impl : virtual public MG::HS {
public:

  // from HS

  virtual void begin(const Ice::Current & curr)
  {
    std::cerr << "begin:\n" << curr.con->toString() << std::endl;
  }
  virtual void end(const Ice::Current & curr)
  {
    std::cerr << "end:\n" << curr.con->toString() << std::endl;
  }

};

//--------------------------------------------------------------------
class HSService : virtual public Ice::Service {
protected:

  // from Ice::Service
  virtual bool start(int argc, char * argv[]);
};

//--------------------------------------------------------------------
bool HSService::start(int argc, char * argv[])
{
  Ice::CommunicatorPtr ic = communicator();

  try {

    // Create adapter.

    Ice::ObjectAdapterPtr adapter
      = ic->createObjectAdapterWithEndpoints("HSAdapter", "default -p 13004");

    // Create the Servant.

    Ice::ObjectPtr object = new HS_impl;
    adapter->add(object, Ice::stringToIdentity("HS"));

    // Activate the Servant.

    adapter->activate();

  }
  catch ( ... ) {
    return false;
  }

  return true;
}

//--------------------------------------------------------------------
int main(int argc, char *argv[])
{
  HSService svc;
  return svc.main(argc, argv);
}
